//+------------------------------------------------------------------+
//| Cyclesurfer.mq4
//| coded by don_forex
//| http://www.forex-tsd.com/suggestions-trading-systems/8247-pro-scalping-tommy-charles.html#post125955
//+------------------------------------------------------------------+
#property copyright "coded by don_forex"
#property link      "http://www.forex-tsd.com/suggestions-trading-systems/8247-pro-scalping-tommy-charles.html#post125955"
#define   NL    "\n"


// Input Variables

extern double  Lots                 = 0.1;
extern int     CleanHole            = 6;
extern int     ProfitTarget         = 10; // How many pips do you want to take profit
extern int     MinimumTimeOpen      = 0; // This is a broker minimum time an order is open in seconds, if you don't have one then the value is 0...

// Internal Variables

int            ProfitCount   = 0;
int            Slippage      = 0;                   
int            MagicNumber   = 29253787337;     
string         TradeComment  = "Cyclesurfer";


int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }




//+---------------------------------------------------+
//| Closes Pocket Buys                 
//+---------------------------------------------------+
void ClosePocketBuy()
{
  double LastBuyTime, OrdersBUY;

   for(int i = OrdersTotal()-1; i >=0; i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY)  
         {
           if (OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
           if (TimeCurrent()-LastBuyTime >=MinimumTimeOpen) result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
  OrdersBUY = 0;
  ProfitCount ++;
  return; 
}
   
//+---------------------------------------------------+
//| Closes Hole Buys                 
//+---------------------------------------------------+
void CloseHoleBuy()
{
  double LastBuyTime, OrdersBUY;

   for(int i = OrdersTotal()-1; i >=0; i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELLLIMIT) result =  OrderDelete(OrderTicket());
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY)  
         {
           if (OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
           if (TimeCurrent()-LastBuyTime >=MinimumTimeOpen) result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
  OrdersBUY = 0;
  ProfitCount = 0;
  return; 
}
   
//+-----------------------------------------------------+
//| Closes Pocket Sells 
//+-----------------------------------------------------+
void ClosePocketSell()
{
  double LastSellTime, OrdersSELL;

   for(int i = OrdersTotal()-1; i >=0; i--)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) 
       {
         if (OrderOpenTime()>LastSellTime) LastSellTime=OrderOpenTime();
         if (TimeCurrent()-LastSellTime >=MinimumTimeOpen) result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
  OrdersSELL = 0;
  ProfitCount ++;
  return; 
}

//+-----------------------------------------------------+
//| Closes Hole Sells 
//+-----------------------------------------------------+
void CloseHoleSell()
{
  double LastSellTime, OrdersSELL;

   for(int i = OrdersTotal()-1; i >=0; i--)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUYLIMIT) result = OrderDelete(OrderTicket());
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) 
       {
         if (OrderOpenTime()>LastSellTime) LastSellTime=OrderOpenTime();
         if (TimeCurrent()-LastSellTime >=MinimumTimeOpen) result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
  OrdersSELL = 0;
  ProfitCount =0;
  return; 
}









int start()
   {
   double         MarginPercent;
   static double  LowMarginPercent=10000000;
   static double  BUY = 1000, SELL;
   double         OrdersBUY, OrdersSELL;
   double         i, j, Spread = Ask-Bid, BuyProfit, SellProfit;
   bool           need_long  = true;
   bool           need_short = true;
   double         WRpercentage = iWPR(NULL, 0, 100, 0);

   for(i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
            {
               if(OrderType()==OP_BUY) need_long = false;
               if(OrderType()==OP_SELL) need_short = false;
               if(OrderType()==OP_BUYLIMIT) need_long = false;
               if(OrderType()==OP_SELLLIMIT) need_short = false;
               if(OrderType()==OP_BUYSTOP)need_long = false;
               if(OrderType()==OP_SELLSTOP)need_short = false;
               if(OrderType()==OP_BUY)  OrdersBUY++;
               if(OrderType()==OP_SELL) OrdersSELL++;
               if(OrderType()==OP_BUY) BUY=OrderOpenPrice();
               if(OrderType()==OP_SELL) SELL=OrderOpenPrice();
               if(OrderType()==OP_BUY)  BuyProfit += (OrderProfit() + OrderCommission() + OrderSwap());
               if(OrderType()==OP_SELL) SellProfit += (OrderProfit() + OrderCommission() + OrderSwap());
            }
      }

//---------------------------------------------------------------------------------------------------------
//   Check for Pocket Profit
//---------------------------------------------------------------------------------------------------------
   if (BuyProfit > ProfitTarget) ClosePocketBuy();

   if (SellProfit > ProfitTarget) ClosePocketSell();
   
//---------------------------------------------------------------------------------------------------------
//   Check for Hole Profit
//---------------------------------------------------------------------------------------------------------
   if (ProfitCount >= CleanHole && OrdersSELL == 0 && MathAbs(BuyProfit) <= ProfitCount / 2) CloseHoleBuy();

   if (ProfitCount >= CleanHole && OrdersBUY == 0 && MathAbs(SellProfit) <= ProfitCount / 2) CloseHoleSell();
   
//---------------------------------------------------------------------------------------------------------
//   Check for Initial Entries
//---------------------------------------------------------------------------------------------------------
   if (OrdersBUY == 0 && OrdersSELL == 0 && WRpercentage == 50)
      {
         OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, TradeComment, MagicNumber, 0, Blue);
         OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, TradeComment, MagicNumber, 0, Red);
      }
      
//---------------------------------------------------------------------------------------------------------
//   Check for Pending Sell
//---------------------------------------------------------------------------------------------------------
   if (need_short && Bid >= SELL)
      {
         OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, TradeComment, MagicNumber, 0, Red);
      }
   if (need_short && Bid <= SELL)
      {
         OrderSend(Symbol(), OP_SELLLIMIT, Lots, SELL, Slippage, 0, 0, TradeComment, MagicNumber, 0, Red);
      }
      
//---------------------------------------------------------------------------------------------------------
//   Check for Pending Buy
//---------------------------------------------------------------------------------------------------------
   if (need_long && Ask <= BUY)
      {
         OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, TradeComment, MagicNumber, 0, Blue);
      }
      
   if (need_long && Ask >= BUY)
      {
         OrderSend(Symbol(), OP_BUYLIMIT, Lots, BUY, Slippage, 0, 0, TradeComment, MagicNumber, 0, Blue);
      }
      
//---------------------------------------------------------------------------------------------------------
//   Comment Block
//---------------------------------------------------------------------------------------------------------
   MarginPercent = MathRound((AccountEquity()/AccountMargin())*100);
   
   if (LowMarginPercent > MarginPercent) LowMarginPercent = MarginPercent;
   

   Comment("                    Cyclesurfer Last Update 06-23-2007 19:21pm", NL,
           "                            ProfitTarget ", ProfitTarget, NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyProfit             ", BuyProfit, NL,
           "                            BUY ", BUY, NL, NL,
           "                            Sells    ", OrdersSELL, NL,
           "                            SellProfit             ", SellProfit, NL,
           "                            SELL    ", SELL, NL, NL,
           "                            ProfitCount ", ProfitCount, NL, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL, NL,
           "                            Margin      ", MathRound(AccountMargin()), NL,
           "                            Current Time is  ",TimeHour(TimeCurrent()),":",TimeMinute(TimeCurrent()),".",TimeSeconds(TimeCurrent()));   

//----------------------------------------------------------//
// Low Margin Percent Label                                 //
//----------------------------------------------------------//

   string MarPercent = DoubleToStr(MarginPercent,0);
   string LowMarPercent = DoubleToStr(LowMarginPercent,0);
   
   string ACCBAL     = DoubleToStr(AccountBalance(),0);
   ObjectDelete("MarginPercent");
   ObjectDelete("LowMarginPercent");
   
   if(ObjectFind("MarginPercent") != 0)
   {
   ObjectCreate("MarginPercent", OBJ_TEXT, 0, Time[0], Close[0]+20*Point);
   ObjectSetText("MarginPercent", MarPercent+"%  "+LowMarPercent+"%   $"+ACCBAL, 24, "Arial", White);
   }
   else
   {
   ObjectMove("MarginPercent", 0, Time[0], Close[0]+20*Point);
   }

//---------------------------------------------------------------------------------------------------------
//   End of Start routine
//---------------------------------------------------------------------------------------------------------
   return;
  }

